Description

One of the core services of the Internet is email, and as such | needed to setup a mail server for one of my projects. Rather than
setting up postfix, dovecot, spamassassin, etc. by hand, | found the useful open source project iRedMail. Unfortunately, this project
currently is not in the port tree, however the install script uses the ports tree to install each of the necessary packages. This guide
uses a FreeBSD 9.2 jail created using FreeNAS, so it should work on a bare metal setup as well; also this guide assumes that SSH
has been enabled and a separate user used to run administrative commands has been created.

Update the system

e |ogin as root:
su -
® Update the ports tree
portsnap fetch extract
e Install portupgrade

cd /usr/ports/ports—-mgmt/portupgrade
make install clean

e Upgrade the base system
portupgrade -a
e Check the current hostname:

hostname -f

o The output should look similar to the following:
mx.example.com

On FreeBSD, hostname is set in two files: /etc/rc.conf, /etc/hosts.

e Add or modify the /etc/rc.conf file:

hostname="mx.example.com"
e Add or modify the /etc/hosts file:

127.0.0.1 mx.example.com mx localhost localhost.localdomain

Install iRedMail

e |nstall bash

portupgrade -Np shells/bash

e (Optional) Install mercurial

portupgrade -Np devel/mercurial

e Fetch and extract the iRedMail stable installer:

cd

fetch https://bitbucket.org/zhb/iredmail/downloads/iRedMail-0.8.7.tar.bz2
tar xjf iRedMail-0.8.7.tar.bz2

cd iRedMail-0.8.7

o Use the latest development installer (Recommended for FreeBSD 9 and higher)

bash

cd /usr/src

hg clone https://bitbucket.org/zhb/iredmail
cd iredmail/iRedMail

¢ Run the iRedMail Installer:

bash iRedMail.sh

Configure iRedMail

The install process will pull in all the required packages during installation. Since each mail server is a little different, my setup uses
the following parameters:

Default mail storage path: /var/vmail
Preferred backend used to store mail accounts: MariaDB
First virtual domain name: example.com
Optional components:
o DKIM signing/verification
o iRedAdmin
o Roundcubemail
phpMyAdmin
o Awstats

(o]

When the installation finishes, all the login information and URLs will be placed in the iRedMail.tips file.
Troubleshooting

* NOTE: The latest stable version, 0.8.7, uses the older version of apache2. | needed to run the following to prevent upgrades
from defaulting to apache24:
echo "USE_APACHE=22+" >> /etc/make.conf

e NOTE: On newer FreeBSD systems apache22 is deprecated, and this will break the iRedMail installer since it depends on
apache22. In order to fix this problem, edit functions/packages_freebsd.sh and make the following change:

DEFAULT_VERSIONS+=python=2.7 python2=2.7 apache=2.2

e NOTE: During the install | came across the following error:

apache22-2.2.29_2 AUTHN_DBD and DBD requires APR-util to have DBD support build in. Please rebuild APR at last with one

DBD backend (MYSQL, PGSQL or SQLITE).

¢ In order to fix this, | needed to reinstall apr1 (this is to compile the modules required for the database backend):
cd /usr/ports/devel/aprl
make reinstall clean

e Then rerun the iRedMail Installer:

cd ~/iRedMail-0.8.7
bash iRedMail.sh

Install Getmail

® |nstall getmail

cd /usr/ports/mail/getmail
portupgrade —-Np

Configuring Getmail

e Unlock the vmail user

chsh -s /bin/sh vmail

o Switch to the vmail user

su - vmail

e Set up the getmail configuration

cd
mkdir .getmail
cp /usr/local/share/examples/getmail/getmailrc-examples .getmail/getmailrc

For user john, with an email address of john@example.com, email user name john, a password of 1234, and an ISP whose pop
server name is pop.example.com, we would like our getmailrc to look like this.

[options]
verbose = 0
mailto:john@example.com

read_all = false
delete = false

[retriever]

type = SimplePOP3Retriever
server = pop.example.com
username = john

password = 1234

[destination]

type = MDA_external

path = /usr/local/libexec/dovecot/deliver

arguments = ("-e", "-f", "%(sender)", "-d", "john@example.com")

Testing Getmail

® To test getmail simply type at a command prompt

getmail -v

If all is set up successfully, you should see it polling your pop server and retrieving your mail.

Automating Getmail

Unlike fetchmail, getmail doesn't have a daemon option, so if you want it to poll your server at regular intervals, you will have to add a
crontab entry. The man 5 crontab page explains things rather clearly, but a quick example.

e On most systems, a user can edit his own crontab. So as user john you would do

crontab -e

And add the following

*/2 * * * * /usr/local/bin/getmail

o This will run getmail every 2 minutes.

Resources

e http://www.iredmail.org/docs/install.iredmail.on.freebsd.html
e http://www.iredmail.org/download.html
¢ https:/bitbucket.org/zhb/iredmail

Related issues:
Copied to FreeBSD Administration - Support #537: Install a Mail Server With i... Closed 11/12/2014

History

#1 - 11/12/2014 12:18 PM - Daniel Curtis
- Description updated

- % Done changed from 0 to 30

#2 - 11/12/2014 12:35 PM - Daniel Curtis
- Description updated

#3 - 11/12/2014 12:47 PM - Daniel Curtis
- Description updated
- Description updated
- Description updated

- Status changed from New to In Progress

#9 - 12/26/2014 11:37 AM - Daniel Curtis

- Description updated

#10 - 12/26/2014 05:31 PM - Daniel Curtis
- Description updated

- % Done changed from 60 to 80

#11 - 12/26/2014 06:43 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 80 to 100

#12 - 12/26/2014 07:19 PM - Daniel Curtis

- Status changed from Resolved to Closed

#13 - 01/20/2015 03:31 PM - Daniel Curtis
- Subject changed from Installing iRedMail Mail Server on FreeBSD 9.2 to Installing iRedMail 0.8.7 Mail Server on FreeBSD 9.2

#14 - 01/20/2015 04:10 PM - Daniel Curtis
- Copied to Support #537: Install a Mail Server With iRedMail 0.9.0 on FreeBSD added

#15 - 02/14/2015 10:42 AM - Daniel Curtis
- Target version set to FreeBSD 9
- Category set to Mail Server
